#include <stdio.h>
#include <vector>
#include <string.h>
#include "xmlParser.h"
#include <iostream>
#include <iomanip>
#include <chrono>
#include <ctime>


void myfree(char *t); // {free(t);}
ToXMLStringTool tx, tx2;


int main(int argc, char **argv) {

    bool influxdb = false;

#ifdef InfluxDB
    influxdb=true;
#endif
    std::string allinput;
    const auto p0 = std::chrono::time_point<std::chrono::system_clock>{};
    auto p1 = std::chrono::system_clock::now();
    while (std::cin.good())     // read all input from cin
    {
        char inbuffer[32768];
        std::cin.read(inbuffer, sizeof(inbuffer));
        allinput.append(inbuffer, std::cin.gcount());
    }

    XMLNode xmeasData = XMLNode::parseString(allinput.c_str(), "measCollecFile").getChildNode("measData");


    XMLElementPosition i = xmeasData.nAttribute(),   // we don't want to list all the attributes
            n = xmeasData.nElement();     // there are in total nElement.
    while (i < n) {

        XMLNodeContents xContent = xmeasData.enumContents(i);
        XMLNode Node = xContent.child;
        i++;

        XMLNode xmeasInfo = Node;
        char *xmeasInfoID = NULL;
        char *jobID = NULL;
        char *measObjLdn = NULL;
        try {
            xmeasInfoID = (char *) xmeasInfo.getAttribute("measInfoId");
        } catch (const std::exception &ex) { ;;
        }

        XMLElementPosition ii = xmeasInfo.nAttribute(),   // we don't want to list all the attributes
                nn = xmeasInfo.nElement();     // there are in total nElement.
        std::string Keys[nn];
        std::vector<std::string> measValues;
        int counter = 0;
        while (ii < nn) {
            XMLNodeContents xnc = xmeasInfo.enumContents(ii);
            if (strcmp(xnc.child.getName(), "measValue") == 0) {
                measObjLdn = (char *) xnc.child.getAttribute("measObjLdn");
                measValues.push_back(measObjLdn);
            }
            if (strcmp(xnc.child.getName(), "job") == 0) {
                jobID = (char *) xnc.child.getAttribute("jobId");
            }
            try {
                Keys[counter] = std::string(xnc.child.getText());
                counter++;
            } catch (const std::exception &ex) { ;;
            }
            ii++;
        }
        for (counter = 0; counter < measValues.size(); counter++) {
            XMLNode xmeasValue = Node.getChildNode("measValue", counter);
            XMLElementPosition iii = xmeasValue.nAttribute(),   // we don't want to list all the attributes
                    nnn = xmeasValue.nElement();     // there are in total nElement.
            while (iii < nnn) {
                XMLNodeContents xnc = xmeasValue.enumContents(iii);
                if (influxdb==false) {
                    printf("%s,%s,%s,%s=%s\n", xmeasInfoID, jobID, std::string(measValues[counter]).c_str(),
                           Keys[iii - 1].c_str(), xnc.child.getText());
                }
                else if (influxdb==true) {
                    p1 = std::chrono::system_clock::now();
                    auto nanotime=std::chrono::duration_cast<std::chrono::nanoseconds>(p1.time_since_epoch()).count();
                    printf("%s,%s,%s,%s^%s^%lu\n", xmeasInfoID, jobID, std::string(measValues[counter]).c_str(),
                           Keys[iii - 1].c_str(), xnc.child.getText(),nanotime);
                }

                iii++;
            }
        }
    }
    return 0;
}

#ifdef _USE_XMLPARSER_DLL
void myfree(char *t){freeXMLString(t);}
#else

void myfree(char *t) { free(t); }

#endif
